package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolEnrollPlanBo;
import org.dromara.art.domain.vo.ArtSchoolEnrollPlanVo;
import org.dromara.art.domain.ArtSchoolEnrollPlan;
import org.dromara.art.mapper.ArtSchoolEnrollPlanMapper;
import org.dromara.art.service.IArtSchoolEnrollPlanService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校招生计划Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolEnrollPlanServiceImpl implements IArtSchoolEnrollPlanService {

    private final ArtSchoolEnrollPlanMapper baseMapper;

    /**
     * 查询学校招生计划
     *
     * @param planId 主键
     * @return 学校招生计划
     */
    @Override
    public ArtSchoolEnrollPlanVo queryById(Long planId){
        return baseMapper.selectVoById(planId);
    }

    /**
     * 分页查询学校招生计划列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校招生计划分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolEnrollPlanVo> queryPageList(ArtSchoolEnrollPlanBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolEnrollPlan> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolEnrollPlanVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校招生计划列表
     *
     * @param bo 查询条件
     * @return 学校招生计划列表
     */
    @Override
    public List<ArtSchoolEnrollPlanVo> queryList(ArtSchoolEnrollPlanBo bo) {
        LambdaQueryWrapper<ArtSchoolEnrollPlan> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolEnrollPlan> buildQueryWrapper(ArtSchoolEnrollPlanBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolEnrollPlan> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolEnrollPlan::getPlanId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolEnrollPlan::getSchoolId, bo.getSchoolId());
        lqw.eq(bo.getYear() != null, ArtSchoolEnrollPlan::getYear, bo.getYear());
        lqw.eq(StringUtils.isNotBlank(bo.getProvince()), ArtSchoolEnrollPlan::getProvince, bo.getProvince());
        lqw.eq(StringUtils.isNotBlank(bo.getSubjectType()), ArtSchoolEnrollPlan::getSubjectType, bo.getSubjectType());
        lqw.eq(bo.getMajorId() != null, ArtSchoolEnrollPlan::getMajorId, bo.getMajorId());
        lqw.like(StringUtils.isNotBlank(bo.getMajorName()), ArtSchoolEnrollPlan::getMajorName, bo.getMajorName());
        lqw.eq(StringUtils.isNotBlank(bo.getEducationLevel()), ArtSchoolEnrollPlan::getEducationLevel, bo.getEducationLevel());
        lqw.eq(bo.getPlanNum() != null, ArtSchoolEnrollPlan::getPlanNum, bo.getPlanNum());
        return lqw;
    }

    /**
     * 新增学校招生计划
     *
     * @param bo 学校招生计划
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolEnrollPlanBo bo) {
        ArtSchoolEnrollPlan add = MapstructUtils.convert(bo, ArtSchoolEnrollPlan.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setPlanId(add.getPlanId());
        }
        return flag;
    }

    /**
     * 修改学校招生计划
     *
     * @param bo 学校招生计划
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolEnrollPlanBo bo) {
        ArtSchoolEnrollPlan update = MapstructUtils.convert(bo, ArtSchoolEnrollPlan.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolEnrollPlan entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校招生计划信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
